"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Session_collection;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Session = void 0;
const ulid_1 = require("ulid");
/**
 * Session Class
 */
class Session {
    /**
     * Construct Session
     * @param collection Collection
     * @param id Id
     */
    constructor(collection, id) {
        _Session_collection.set(this, void 0);
        __classPrivateFieldSet(this, _Session_collection, collection, "f");
        this.id = id;
    }
    /**
     * Convert to string
     * @returns String
     */
    toString() {
        return this.name;
    }
    /**
     * Time when this session was created
     */
    get createdAt() {
        return new Date((0, ulid_1.decodeTime)(this.id));
    }
    /**
     * Whether this is the current session
     */
    get current() {
        return this.id === __classPrivateFieldGet(this, _Session_collection, "f").client.sessionId;
    }
    /**
     * Name
     */
    get name() {
        return __classPrivateFieldGet(this, _Session_collection, "f").getUnderlyingObject(this.id).name;
    }
    /**
     * Rename a session
     * @param name New name
     */
    rename(name) {
        return __awaiter(this, void 0, void 0, function* () {
            yield __classPrivateFieldGet(this, _Session_collection, "f").client.api.patch(`/auth/session/${this.id}`, {
                friendly_name: name,
            });
            __classPrivateFieldGet(this, _Session_collection, "f").updateUnderlyingObject(this.id, "name", name);
        });
    }
    /**
     * Delete a session
     */
    delete() {
        return __awaiter(this, void 0, void 0, function* () {
            yield __classPrivateFieldGet(this, _Session_collection, "f").client.api.delete(`/auth/session/${this.id}`);
            __classPrivateFieldGet(this, _Session_collection, "f").delete(this.id);
        });
    }
}
exports.Session = Session;
_Session_collection = new WeakMap();
