import { API } from "..";
import { ChannelWebhook } from "../classes/ChannelWebhook";
import { HydratedChannelWebhook } from "../hydration/channelWebhook";
import { ClassCollection } from ".";
/**
 * Collection of Channel Webhooks
 */
export declare class ChannelWebhookCollection extends ClassCollection<ChannelWebhook, HydratedChannelWebhook> {
    /**
     * Fetch webhook by ID
     * @param id Id
     * @returns Webhook
     */
    fetch(id: string): Promise<ChannelWebhook>;
    /**
     * Create webhook with ID and token
     * @param id Id
     * @param token Token
     * @returns Webhook
     */
    fromToken(id: string, token: string): Promise<ChannelWebhook>;
    /**
     * Get or create
     * @param id Id
     * @param data Data
     */
    getOrCreate(id: string, data: API.Webhook): ChannelWebhook;
}
//# sourceMappingURL=ChannelWebhookCollection.d.ts.map