import { DataEditWebhook } from "revolt-api";
import { ChannelWebhookCollection } from "../collections";
/**
 * Channel Webhook Class
 */
export declare class ChannelWebhook {
    #private;
    readonly id: string;
    /**
     * Construct Channel Webhook
     * @param collection Collection
     * @param id Webhook
     */
    constructor(collection: ChannelWebhookCollection, id: string);
    /**
     * Webhook name
     */
    get name(): string;
    /**
     * Webhook avatar
     */
    get avatar(): import("./File").File | undefined;
    /**
     * Webhook avatar URL
     */
    get avatarURL(): string | undefined;
    /**
     * Channel ID this webhook belongs to
     */
    get channelId(): string;
    /**
     * Channel this webhook belongs to
     */
    get channel(): import("./Channel").Channel | undefined;
    /**
     * Secret token for sending messages to this webhook
     */
    get token(): string;
    /**
     * Edit this webhook
     */
    edit(data: DataEditWebhook): Promise<void>;
    /**
     * Delete this webhook
     */
    delete(): Promise<void>;
}
//# sourceMappingURL=ChannelWebhook.d.ts.map