import { API } from "..";
import { Session } from "../classes";
import { HydratedSession } from "../hydration/session";
import { ClassCollection } from ".";
/**
 * Collection of Sessions
 */
export declare class SessionCollection extends ClassCollection<Session, HydratedSession> {
    /**
     * Fetch active sessions
     * @returns List of sessions
     */
    fetch(): Promise<Session[]>;
    /**
     * Delete all sessions, optionally including self
     * @param revokeSelf Whether to remove current session too
     */
    deleteAll(revokeSelf?: boolean): Promise<void>;
    /**
     * Get or create
     * @param id Id
     * @param data Data
     * @returns Session
     */
    getOrCreate(id: string, data: API.SessionInfo): Session;
}
//# sourceMappingURL=SessionCollection.d.ts.map