import { ReactiveMap } from "@solid-primitives/map";
import { ReactiveSet } from "@solid-primitives/set";
import { API, File, MessageEmbed, MessageWebhook, SystemMessage } from "..";
import type { Merge } from "../lib/merge";
import { Hydrate } from ".";
export type HydratedMessage = {
    id: string;
    nonce?: string;
    channelId: string;
    authorId?: string;
    webhook?: MessageWebhook;
    content?: string;
    systemMessage?: SystemMessage;
    attachments?: File[];
    editedAt?: Date;
    embeds?: MessageEmbed[];
    mentionIds?: string[];
    replyIds?: string[];
    reactions: ReactiveMap<string, ReactiveSet<string>>;
    interactions?: API.Interactions;
    masquerade?: API.Masquerade;
};
export declare const messageHydration: Hydrate<Merge<API.Message>, HydratedMessage>;
//# sourceMappingURL=message.d.ts.map